## tarantool 1.4.7+20120714

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(tarantool)

include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckSymbolExists)
include(CheckCXXSourceRuns)
include(TestBigEndian)
include(CheckFunctionExists)

find_program(ECHO echo)
find_program(XSLTPROC xsltproc)
find_program(XMLLINT xmllint)
find_program(JING jing)
find_program(LYNX lynx)
find_program(CAT cat)
find_program(GIT git)
find_program(RAGEL ragel)
find_program(CONFETTI confetti)
find_program(LD ld)
find_program(POD2MAN pod2man)

#
# This instructs the rest of the build system what product
# and what modules to produce.
#
set (TARANTOOL_PRODUCT "box")
set (TARANTOOL_MODULES "box")
set (TARANTOOL_CLIENTS "")

#
# Set default build type to Debug. This is to ease a developer's
# life. Release binaries are built by BuildBot automatically anyway.
#
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

# the order is significant: we need to know os and compiler to configure libs
include(cmake/arch.cmake)
include(cmake/os.cmake)
include(cmake/compiler.cmake)
# 
# Since we *optionally* build bundled libs, a direct build
# dependency between tarantool_box and libluajit/libobjc won't
# wor: dadd an empty custom target for this dependency instead.
# If a bundled objc or luajit is built, it is added to the
# dependency list of build_bundled_libs target.
#
add_custom_target(build_bundled_libs)
include(cmake/libobjc.cmake)
include(cmake/luajit.cmake)

check_symbol_exists(MAP_ANON sys/mman.h HAVE_MAP_ANON)
check_symbol_exists(MAP_ANONYMOUS sys/mman.h HAVE_MAP_ANONYMOUS)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(unwind.h HAVE_UNWIND_H)
check_include_file(cpuid.h HAVE_CPUID_H)

check_symbol_exists(O_DSYNC fcntl.h HAVE_O_DSYNC)
check_function_exists(fdatasync HAVE_FDATASYNC)
check_function_exists(memmem HAVE_MEMMEM)
check_function_exists(memrchr HAVE_MEMRCHR)

#
# Some versions of GNU libc define non-portable __libc_stack_end
# which we use to determine the end (or beginning, actually) of
# stack. Find whether or not it's present.
check_library_exists("" __libc_stack_end "" HAVE_LIBC_STACK_END)

#
# Enable 'make TAGS' target.
#
add_custom_target(TAGS COMMAND ctags -R --langmap=ObjectiveC:.m -e -f TAGS
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

#
# Define TARANTOOL_VERSION -- a string constant with tarantool version.
#
set (TARANTOOL_VERSION "")
execute_process (COMMAND ${GIT} describe HEAD
    OUTPUT_VARIABLE TARANTOOL_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
#
# Make sure the version is set even if building
# out of source.
#
set (CPACK_PACKAGE_VERSION_MAJOR "1")
set (CPACK_PACKAGE_VERSION_MINOR "4")
set (CPACK_PACKAGE_VERSION_PATCH "7")
if (TARANTOOL_VERSION STREQUAL "")
    set (TARANTOOL_VERSION
        "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif()

#
# Specify where to look for include files.
#
include_directories("${PROJECT_SOURCE_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/include")
include_directories("${PROJECT_BINARY_DIR}/include")
include_directories("${PROJECT_SOURCE_DIR}/connector/c/include")
#
# Specify prefixes
#
if (NOT DEFINED CMAKE_SYSCONF_DIR)
    set (CMAKE_SYSCONF_DIR "etc")
endif()
if (NOT DEFINED CMAKE_LOCALSTATE_DIR)
    set (CMAKE_LOCALSTATE_DIR "var")
endif()
if (NOT DEFINED CMAKE_MAN_DIR)
    set (CMAKE_MAN_DIR "man")
endif()

#
# Now handle all configuration options.
#
option(ENABLE_DOC "Enable building of documentation" OFF)

option(ENABLE_CLIENT "Enable building of console client" OFF)
if (ENABLE_CLIENT)
    set (TARANTOOL_CLIENTS ${TARANTOOL_CLIENTS} "tarantool")
endif()

option(ENABLE_GCOV "Enable integration with gcov, a code coverage program" OFF)
if (ENABLE_GCOV)
    check_library_exists (gcov __gcov_flush  ""  HAVE_GCOV)
    if (NOT HAVE_GCOV)
        message (FATAL_ERROR
                 "ENABLE_GCOV option requested but gcov library is not found")
    endif()
    set (GCOV_C_FLAGS "-fprofile-arcs -ftest-coverage")
    set (GCOV_LDFLAGS "-fprofile-arcs -ftest-coverage")
endif()

option(ENABLE_TRACE "Enable debug trace of tarantool_box execution to
a file specified in TARANTOOL_TRACE environment variable" ON)

option(ENABLE_BACKTRACE "Enable output of fiber backtrace information in 'show
fiber' administrative command. Only works on x86 architectures, if compiled
with gcc. If GNU binutils and binutils-dev libraries are installed, backtrace
is output with resolved function (symbol) names. Otherwise only frame
addresses are printed." ${CMAKE_COMPILER_IS_GNUCC})

set (HAVE_BFD False)
if (ENABLE_BACKTRACE)
    if (NOT ${CMAKE_COMPILER_IS_GNUCC} OR
        NOT (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86|amd64"))
        # We only know this option to work with gcc
        # on x86 architecture.
        message (FATAL_ERROR "ENABLE_BACKTRACE option is set but the system is not x86 based (${CMAKE_SYSTEM_PROCESSOR}) or the compiler is not GNU GCC (${CMAKE_C_COMPILER}).")
    endif()
    # Use GNU bfd if present.
    check_library_exists (bfd bfd_init ""  HAVE_BFD_LIB)
    check_include_file(bfd.h HAVE_BFD_H)
    if (HAVE_BFD_LIB AND HAVE_BFD_H)
        set (HAVE_BFD True)
    endif()
endif()

option(ENABLE_STATIC "Perform static linking whenever possible." OFF)
if (ENABLE_STATIC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -static")
endif()

add_subdirectory(third_party)
add_subdirectory(cfg)
add_subdirectory(connector)
add_subdirectory(src)
add_subdirectory(extra)
add_subdirectory(mod)
add_subdirectory(client)
add_subdirectory(test)
add_subdirectory(doc)

install (FILES README LICENSE doc/box-protocol.txt
         DESTINATION share/doc/tarantool)

include (cmake/tarantool_cpack.cmake)

# tarantool info summary (used in server version output)
#
set(TARANTOOL_OPTIONS "-DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_STATIC=${ENABLE_STATIC} -DENABLE_GCOV=${ENABLE_GCOV}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_TRACE=${ENABLE_TRACE} -DENABLE_BACKTRACE=${ENABLE_BACKTRACE}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_CLIENT=${ENABLE_CLIENT}")
set(TARANTOOL_BUILD "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}-${CMAKE_BUILD_TYPE}")
set(TARANTOOL_COMPILER ${CMAKE_C_COMPILER})

#
# Output compile-time defines into config.h. Do it at the end
# of the script to make sure all variables are set.
#
configure_file(
    "${PROJECT_SOURCE_DIR}/include/config.h.cmake"
    "${PROJECT_BINARY_DIR}/include/config.h"
    )
configure_file(
    "${PROJECT_SOURCE_DIR}/doc/tnt.ent.cmake"
    "${PROJECT_BINARY_DIR}/doc/tnt.ent"
    )

configure_file(
    "${PROJECT_SOURCE_DIR}/doc/www-data.in/download.cmake"
    "${PROJECT_BINARY_DIR}/doc/www-data.in/download"
    )
message (STATUS "")
message (STATUS "Tarantool configuration is complete:")
message (STATUS "")
message (STATUS "VERSION: ${TARANTOOL_VERSION}")
message (STATUS "BUILD: ${TARANTOOL_BUILD}")
message (STATUS "COMPILER: ${TARANTOOL_COMPILER}")
message (STATUS "CFLAGS:${CMAKE_C_FLAGS} ${core_cflags}")
message (STATUS "PREFIX: ${CMAKE_INSTALL_PREFIX}")
message (STATUS "MODULES: ${TARANTOOL_MODULES}")
message (STATUS "ENABLE_STATIC: ${ENABLE_STATIC}")
message (STATUS "ENABLE_GCOV: ${ENABLE_GCOV}")
message (STATUS "ENABLE_TRACE: ${ENABLE_TRACE}")
message (STATUS "ENABLE_BACKTRACE: ${ENABLE_BACKTRACE} (symbol resolve: ${HAVE_BFD})")
message (STATUS "ENABLE_CLIENT: ${ENABLE_CLIENT}")
message (STATUS "ENABLE_BUNDLED_LUAJIT: ${ENABLE_BUNDLED_LUAJIT}")
message (STATUS "ENABLE_DOC: ${ENABLE_DOC}")
message (STATUS "")
message (STATUS "To view or modify configuration results, check out CMakeCache.txt.")
message (STATUS "")

=== cfg/CMakeLists.txt ===

# Do not clean the generated configuration files in "make clean"
#
set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM 1)

execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/cfg/prscfg.h
    ${CMAKE_SOURCE_DIR}/cfg/prscfg.c)
add_custom_command(
    OUTPUT ${CMAKE_SOURCE_DIR}/cfg/prscfg.h
           ${CMAKE_SOURCE_DIR}/cfg/prscfg.c
    COMMAND ${ECHO} '%{' > tmp.cfg
    COMMAND ${ECHO} '\#include \"cfg/warning.h\"' >> tmp.cfg
    COMMAND ${ECHO} '%}' >> tmp.cfg
    COMMAND ${CAT} ${CMAKE_SOURCE_DIR}/cfg/core_cfg.cfg_tmpl >> tmp.cfg
    COMMAND ${CONFETTI} -i tmp.cfg -n tarantool_cfg
            -H ${CMAKE_SOURCE_DIR}/cfg/prscfg.h
            -p ${CMAKE_SOURCE_DIR}/cfg/prscfg.c
    COMMAND ${CMAKE_COMMAND} -E remove tmp.cfg
    DEPENDS ${CMAKE_SOURCE_DIR}/cfg/warning.h)

#
# Optionally rebuild the configuration file parsing code from
# templates.
#
macro(generate_mod_config mod)
# Gracefully handle out-of-source builds with missing 
# 'confetti'. Make sure that generated files are older than
# their sources when configuring the project.
execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h
    ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c)
add_custom_command(
    OUTPUT ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h
           ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
    COMMAND ${ECHO} '%{' > ${mod}_tmp.cfg
    COMMAND ${ECHO} '\#include \"cfg/warning.h\"' >> ${mod}_tmp.cfg
    COMMAND ${ECHO} '\#include \"cfg/tarantool_${mod}_cfg.h\"' >> ${mod}_tmp.cfg
    COMMAND ${ECHO} '%}' >> ${mod}_tmp.cfg
    COMMAND ${CAT} ${CMAKE_SOURCE_DIR}/cfg/core_cfg.cfg_tmpl >> ${mod}_tmp.cfg
    COMMAND ${CAT} ${CMAKE_SOURCE_DIR}/mod/${mod}/${mod}_cfg.cfg_tmpl >>
            ${mod}_tmp.cfg
    COMMAND ${CONFETTI} -i ${mod}_tmp.cfg -n tarantool_cfg
            -c ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
            -h ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h
    COMMAND ${CMAKE_COMMAND} -E remove ${mod}_tmp.cfg
    DEPENDS ${CMAKE_SOURCE_DIR}/cfg/core_cfg.cfg_tmpl
            ${CMAKE_SOURCE_DIR}/cfg/warning.h
            ${CMAKE_SOURCE_DIR}/mod/${mod}/${mod}_cfg.cfg_tmpl
    )
endmacro()

foreach (mod ${TARANTOOL_MODULES})
  generate_mod_config(${mod})
  set (generated_headers ${generated_headers} 
       ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h)
endforeach()

set_source_files_properties(${CMAKE_SOURCE_DIR}/cfg/prscfg.c
    PROPERTIES COMPILE_FLAGS "-Wno-unused")

add_library(cfg prscfg.c warning.c)
#
# Make sure all generated headers are built before they are used.
# This is also necessary to avoid races in parallel make,
# when tmp.cfg is corrupted by two paralled targets.
# See http://www.cmake.org/Bug/view.php?id=10082 for details.
#
add_custom_target(config
    DEPENDS ${CMAKE_SOURCE_DIR}/cfg/prscfg.h ${generated_headers})

=== mod/CMakeLists.txt ===

function(tarantool_module mod)
    set (module_sources ${ARGN})
    set_source_files_properties(
        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
        PROPERTIES COMPILE_FLAGS "-Wno-unused" GENERATED True)
    add_executable(tarantool_${mod}
        ${module_sources}
        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c)

    set_source_files_properties(${recompiled_sources}
        PROPERTIES OBJECT_DEPENDS
        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h)

    add_library(lt${mod} STATIC ${recompiled_sources})
    set_target_properties(lt${mod} PROPERTIES COMPILE_FLAGS
        "${core_cflags} ${GCOV_C_FLAGS} -DTARANTOOL_CONFIG='<cfg/tarantool_${mod}_cfg.h>'")
    add_dependencies(lt${mod} generate_headers generate_admin_m build_bundled_libs)

    target_link_libraries(tarantool_${mod} lt${mod} ${GCOV_LDFLAGS} ${common_libraries})
    set_target_properties(tarantool_${mod} PROPERTIES COMPILE_FLAGS
        "${core_cflags} ${GCOV_C_FLAGS}")

    if (ENABLE_STATIC)
        set_target_properties(tarantool_${mod} PROPERTIES
            LINK_SEARCH_END_STATIC ON)
        set (module_link_flags "${module_link_flags} -static")
    endif()

    if (module_link_flags)
        set_target_properties(tarantool_${mod} PROPERTIES
            LINK_FLAGS ${module_link_flags})
    endif()
    install (TARGETS tarantool_${mod} DESTINATION bin)
endfunction()

foreach (module ${TARANTOOL_MODULES})
add_subdirectory(${module})
endforeach()

=== src/CMakeLists.txt ===
#
# libev library
#
add_library(ev tarantool_ev.c)

if (CC_HAS_WNO_UNUSED_RESULT)
    set (ev_flags "-Wno-unused-result")
endif()
if (CC_HAS_WNO_UNUSED_VALUE)
    set (ev_flags "${ev_flags} -Wno-unused-value")
endif()
if(CMAKE_COMPILER_IS_CLANG)
    set (ev_flags "${ev_flags} -Wno-comment")
endif()
if (CC_HAS_WNO_BITWISE_OP_PARENTHESES)
    set (ev_flags "${ev_flags} -Wno-bitwise-op-parentheses")
endif()
set_source_files_properties(tarantool_ev.c
    PROPERTIES COMPILE_FLAGS "${ev_flags}")
unset (ev_flags)

if (TARGET_OS_LINUX)
#
# Enable Linux-specific event notification API (man inotify)
  set_target_properties(ev PROPERTIES COMPILE_FLAGS "-DEV_USE_INOTIFY")
elseif (TARGET_OS_FREEBSD)
#
# On FreeBSD build libev loop on top of
  set_target_properties(ev PROPERTIES COMPILE_FLAGS "-DEV_USE_KQUEUE")
endif()

#
# libev uses ceil and floor from the standard math library
#

#
# libev depends on librt under kFreeBSD
if (TARGET_OS_DEBIAN_FREEBSD)
  set (ev_libs m rt)
else()
  set (ev_libs m)
endif()

target_link_libraries(ev ${ev_libs})

#
# Build admin.m from admin.rl, but only if admin.rl was changed.
# The same applies to memcached.m/memcached.rl.
# We track admin.m and memcached.m in revision control, and thus do not
# require engineers who do not modify .rl files to have Ragel
# installed.
#
add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/src/admin.m
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${RAGEL} -G2 src/admin.rl -o src/admin.m
    DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.rl)

add_custom_target(generate_admin_m DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.m)
# do not randomly try to re-generate admin.m after a fresh checkout
execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/src/admin.m)

#
# Do not clean admin.m, memcached.m or other
# generated files in 'make clean' -- they are under
# revision control.
#
set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM 1)

#
# Used by modules.
#
set (recompiled_sources
     ${CMAKE_SOURCE_DIR}/src/tarantool.m
     ${CMAKE_SOURCE_DIR}/src/tarantool_lua.m
     ${CMAKE_SOURCE_DIR}/src/say.m
     ${CMAKE_SOURCE_DIR}/src/assoc.m
     ${CMAKE_SOURCE_DIR}/src/admin.m
     ${CMAKE_SOURCE_DIR}/src/replication.m
     ${CMAKE_SOURCE_DIR}/src/fiber.m PARENT_SCOPE)

set (common_sources tbuf.m palloc.m util.m
     salloc.m pickle.m coro.m stat.m log_io.m recovery.m cpu_feature.m
     replica.m iproto.m object.m exception.m errcode.c errinj.m latch.m
     nio.c crc32.c)

if (ENABLE_TRACE)
    set (common_sources ${common_sources} trace.m)
endif()

add_library(core STATIC ${common_sources})
add_dependencies(core generate_headers)
set_target_properties(core PROPERTIES COMPILE_FLAGS "${core_cflags}")

set (common_libraries cfg core ev coro gopt misc)

set (THREAD_LIB pthread)
if (ENABLE_STATIC)
    set (THREAD_LIB -Wl,--whole-archive pthread -Wl,--no-whole-archive)
endif()

set (common_libraries ${common_libraries} ${LUAJIT_LIB} ${LIBOBJC_LIB} ${THREAD_LIB})

if (TARGET_OS_LINUX OR TARGET_OS_DEBIAN_FREEBSD)
    set (common_libraries ${common_libraries} dl)
endif()

if (ENABLE_GCOV)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GCOV_C_FLAGS}")
    set (LDFLAGS "${LDFLAGS} ${GCOV_LDFLAGS}")
    set (common_libraries ${common_libraries} gcov)
endif()

if (ENABLE_BACKTRACE AND HAVE_BFD)
    set (common_libraries ${common_libraries} bfd)
    if (NOT TARGET_OS_DARWIN)
        set (common_libraries ${common_libraries} iberty)
    endif()
    if (ENABLE_STATIC OR TARGET_OS_FREEBSD)
        include (FindZLIB)
        set (common_libraries ${common_libraries} ${ZLIB_LIBRARIES})
    endif()
endif()

set (common_libraries ${common_libraries} PARENT_SCOPE)

=== test/unit/CMakeLists.txt ===
add_executable(queue queue.c)
add_executable(mhash mhash.c)
add_executable(objc_finally objc_finally.m)
add_executable(objc_catchcxx objc_catchcxx.m)
set_target_properties(mhash PROPERTIES COMPILE_FLAGS "-std=c99")
target_link_libraries(objc_finally ${LIBOBJC_LIB})
target_link_libraries(objc_catchcxx ${LIBOBJC_LIB} ${LUAJIT_LIB})
if (TARGET_OS_LINUX OR TARGET_OS_DEBIAN_FREEBSD)
    target_link_libraries(objc_catchcxx dl)
endif()

=== debian/changelog ===
tarantool (1.4.7+20120714-1) unstable; urgency=low

  * Fixed memcached space and some troubles in build system.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sat, 14 Jul 2012 10:05:37 +0400

tarantool (1.4.7-1) unstable; urgency=low

  * New upstream stable version.
    - can be built by gcc-4.7;
    - new transaction processor;
    - add libtarantoolrpl library (provides replication protocol);
    - extract perl and php drivers to their own repositaries.
    - etc

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 11 Jul 2012 10:06:52 +0400

=== debian/control ===
Source: tarantool
Priority: optional
Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Build-Depends: cdbs, debhelper (>= 8),
 gobjc,
 cmake,
 libreadline-dev,
 python-yaml,
 python-daemon,
 python-pexpect,
 libncurses5-dev,
 binutils-dev,
 dpkg-dev (>= 1.16.1~)
Section: database
Standards-Version: 3.9.3
Homepage: http://tarantool.org/
VCS-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tarantool.git;a=summary
VCS-Git: git+ssh://git.debian.org/git/collab-maint/tarantool.git

Package: tarantool-common
Architecture: all
Priority: optional
Depends: ${misc:Depends}, adduser
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides configs and logs infrastructure for tarantool.

Package: tarantool
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, tarantool-common
Suggests: libmr-tarantool-perl, libdr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides tarantool server.

Package: tarantool-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     tarantool (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for tarantool.

Package: tarantool-client
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libmr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides readline client for tarantool.

Package: tarantool-client-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     tarantool-client (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides readline client for tarantool (debug symbols).

Package: libtarantool1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides c-connector library for tarantool.

Package: libtarantool1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantool1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantool1.

Package: libtarantool-dev
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends},
 libtarantool1 (= ${binary:Version}),
 libtarantoolnet1 (= ${binary:Version}),
 libtarantoolsql1 (= ${binary:Version}),
 libtarantoolrpl1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides headers for libtarantool* libraries.

Package: libtarantoolnet1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides c-connector library for tarantool (network).

Package: libtarantoolnet1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantoolnet1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantoolnet1.

Package: libtarantoolsql1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides SQL-parser for tarantool.

Package: libtarantoolsql1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantoolsql1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantoolsql1.

Package: libtarantoolrpl1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides c-connector library for tarantool
 (xlog and replication support).

Package: libtarantoolrpl1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantoolsql1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantoolrpl1.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


VERSION  := $(shell dpkg-parsechangelog|grep ^Version|awk '{print $$2}')
UVERSION := $(shell echo $(VERSION)|sed 's/-[[:digit:]]\+$$//')

DEB_CMAKE_EXTRA_FLAGS := \
	-DCMAKE_BUILD_TYPE=RelWithDebugInfo \
	-DENABLE_CLIENT=true

DEB_DH_INSTALLINIT_ARGS := --name=tarantool

DEB_CMAKE_INSTALL_PREFIX := /usr
DEB_CMAKE_NORMAL_ARGS := -DCMAKE_INSTALL_PREFIX="$(DEB_CMAKE_INSTALL_PREFIX)" \
    -DCMAKE_C_FLAGS="$(CFLAGS)" \
    -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
    -DCMAKE_CPP_FLAGS="$(CPPFLAGS)" \
    -DCMAKE_LD_FLAGS="$(LDFLAGS)" \
    -DCMAKE_SKIP_RPATH=ON \
    -DCMAKE_VERBOSE_MAKEFILE=ON \
    -DCMAKE_SYSCONF_DIR=/etc/tarantool \
    -DCMAKE_LOCALSTATE_DIR=/var
#     -DENABLE_STATIC=ON
#    -DCMAKE_C_COMPILER:FILEPATH="$(CC)" \
#    -DCMAKE_CXX_COMPILER:FILEPATH="$(CXX)" \


include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_BUILDDIR := build-area

tarball: clean
	cd .. && tar --exclude=.git --exclude=debian \
		-czf tarantool_$(UVERSION).orig.tar.gz tarantool-$(UVERSION)

clean::
	find -type f -name \*.pyc -delete
#	find test -name \*.reject -delete

install/tarantool-dbg::
	rm -fr debian/tarantool-dbg/usr/share/doc/tarantool-dbg

install/tarantool::
#         make -C build-area test-force || /bin/true


install/tarantool-common::
	pod2man -c 'tarantool instances control' \
	    debian/tarantool_instance.pod > build-area/tarantool_instance.1
	pod2man -c 'tarantool log rotation' \
	    debian/scripts/tarantool_logrotate \
	    	 > build-area/tarantool_logrotate.1
	install -m0755 extra/logger.pl \
	    debian/tarantool-common/usr/lib/tarantool/logger

## tarantool 1.4.7+20121010.2202

=== debian/changelog ===
tarantool (1.4.7+20121010.2202-1) unstable; urgency=low

  * New snapshot (Don't exit on a trivial socket error).

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 10 Oct 2012 22:01:58 +0400

tarantool (1.4.7+20121010-1) unstable; urgency=low

  * New snapshot.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 10 Oct 2012 17:22:26 +0400

tarantool (1.4.7+20120918-1) unstable; urgency=low

  * New snapshot (some fixes in lua:box.slab).

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 18 Sep 2012 21:57:51 +0400

tarantool (1.4.7+20120915-1) unstable; urgency=low

  * New snapshot (enable box.info, box.slab, box.stat, etc)

 -- Dmitry E. Oboukhov <unera@debian.org>  Sat, 15 Sep 2012 00:02:10 +0400

tarantool (1.4.7+20120905-1) unstable; urgency=low

  * New snapshot.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 05 Sep 2012 15:36:27 +0400

tarantool (1.4.7+20120829-1) unstable; urgency=low

  * New snapshot (some fixes, add box.uuid() and box.uuid_hex() functions).

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 29 Aug 2012 16:46:58 +0400

tarantool (1.4.7+20120820-1) unstable; urgency=low

  * New snapshot (fixed tuple:transform crash).

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 20 Aug 2012 21:42:21 +0400

tarantool (1.4.7+20120817-1) unstable; urgency=low

  * New upstream version.
   + Add WAL rotate script.
  * Add all contributors to debian/copyright (fix lintian warning).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 03 Aug 2012 12:09:14 +0400

=== debian/rules ===
--- 
+++ 
@@ -54,5 +54,8 @@
 	pod2man -c 'tarantool log rotation' \
 	    debian/scripts/tarantool_logrotate \
 	    	 > build-area/tarantool_logrotate.1
+	pod2man -c 'snapshot rotate' \
+	    debian/scripts/tarantool_snapshot_rotate \
+	    	> build-area/tarantool_snapshot_rotate.1
 	install -m0755 extra/logger.pl \
 	    debian/tarantool-common/usr/lib/tarantool/logger

## tarantool 1.4.8+20121207

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,9 @@
 #
 set (TARANTOOL_PRODUCT "box")
 set (TARANTOOL_MODULES "box")
-set (TARANTOOL_CLIENTS "")
+set (TARANTOOL_CLIENTS "tarantool_checksum")
+# Define PACKAGE macro in config.h
+set (PACKAGE "Tarantool")
 
 #
 # Set default build type to Debug. This is to ease a developer's
@@ -79,11 +81,11 @@
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 
 #
-# Define TARANTOOL_VERSION -- a string constant with tarantool version.
-#
-set (TARANTOOL_VERSION "")
+# Define PACKAGE_VERSION -- a string constant with tarantool version.
+#
+set (PACKAGE_VERSION "")
 execute_process (COMMAND ${GIT} describe HEAD
-    OUTPUT_VARIABLE TARANTOOL_VERSION
+    OUTPUT_VARIABLE PACKAGE_VERSION
     OUTPUT_STRIP_TRAILING_WHITESPACE
     )
 #
@@ -92,9 +94,9 @@
 #
 set (CPACK_PACKAGE_VERSION_MAJOR "1")
 set (CPACK_PACKAGE_VERSION_MINOR "4")
-set (CPACK_PACKAGE_VERSION_PATCH "7")
-if (TARANTOOL_VERSION STREQUAL "")
-    set (TARANTOOL_VERSION
+set (CPACK_PACKAGE_VERSION_PATCH "8")
+if (PACKAGE_VERSION STREQUAL "")
+    set (PACKAGE_VERSION
         "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 endif()
 
@@ -158,7 +160,9 @@
     endif()
     # Use GNU bfd if present.
     check_library_exists (bfd bfd_init ""  HAVE_BFD_LIB)
+    set(CMAKE_REQUIRED_DEFINITIONS -DPACKAGE=${PACKAGE} -DPACKAGE_VERSION=${PACKAGE_VERSION})
     check_include_file(bfd.h HAVE_BFD_H)
+    set(CMAKE_REQUIRED_DEFINITIONS)
     if (HAVE_BFD_LIB AND HAVE_BFD_H)
         set (HAVE_BFD True)
     endif()
@@ -174,7 +178,6 @@
 add_subdirectory(connector)
 add_subdirectory(src)
 add_subdirectory(extra)
-add_subdirectory(mod)
 add_subdirectory(client)
 add_subdirectory(test)
 add_subdirectory(doc)
@@ -182,7 +185,7 @@
 install (FILES README LICENSE doc/box-protocol.txt
          DESTINATION share/doc/tarantool)
 
-include (cmake/tarantool_cpack.cmake)
+include (cmake/cpack.cmake)
 
 # tarantool info summary (used in server version output)
 #
@@ -213,7 +216,7 @@
 message (STATUS "")
 message (STATUS "Tarantool configuration is complete:")
 message (STATUS "")
-message (STATUS "VERSION: ${TARANTOOL_VERSION}")
+message (STATUS "VERSION: ${PACKAGE_VERSION}")
 message (STATUS "BUILD: ${TARANTOOL_BUILD}")
 message (STATUS "COMPILER: ${TARANTOOL_COMPILER}")
 message (STATUS "CFLAGS:${CMAKE_C_FLAGS} ${core_cflags}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,11 +9,14 @@
 if (CC_HAS_WNO_UNUSED_VALUE)
     set (ev_flags "${ev_flags} -Wno-unused-value")
 endif()
-if(CMAKE_COMPILER_IS_CLANG)
+if(CC_HAS_WNO_COMMENT)
     set (ev_flags "${ev_flags} -Wno-comment")
 endif()
-if (CC_HAS_WNO_BITWISE_OP_PARENTHESES)
-    set (ev_flags "${ev_flags} -Wno-bitwise-op-parentheses")
+if(CC_HAS_FNO_STRICT_ALIASING)
+    set (ev_flags "${ev_flags} -fno-strict-aliasing")
+endif()
+if (CC_HAS_WNO_PARENTHESES)
+    set (ev_flags "${ev_flags} -Wno-parentheses")
 endif()
 set_source_files_properties(tarantool_ev.c
     PROPERTIES COMPILE_FLAGS "${ev_flags}")
@@ -44,6 +47,11 @@
 target_link_libraries(ev ${ev_libs})
 
 #
+# libeio library
+#
+add_library(eio tarantool_eio.c)
+
+#
 # Build admin.m from admin.rl, but only if admin.rl was changed.
 # The same applies to memcached.m/memcached.rl.
 # We track admin.m and memcached.m in revision control, and thus do not
@@ -55,34 +63,82 @@
     COMMAND ${RAGEL} -G2 src/admin.rl -o src/admin.m
     DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.rl)
 
+add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/src/memcached-grammar.m
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+    COMMAND ${RAGEL} -G2 src/memcached-grammar.rl
+                     -o src/memcached-grammar.m
+    DEPENDS ${CMAKE_SOURCE_DIR}/src/memcached-grammar.rl)
+
 add_custom_target(generate_admin_m DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.m)
-# do not randomly try to re-generate admin.m after a fresh checkout
+add_custom_target(generate_memcached_grammar_m DEPENDS
+    ${CMAKE_SOURCE_DIR}/src/memcached-grammar.m)
+
+# do not randomly try to re-generate admin.m or memcached-grammar.m
+# after a fresh checkout/branch switch.
 execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
-    ${CMAKE_SOURCE_DIR}/src/admin.m)
+    ${CMAKE_SOURCE_DIR}/src/admin.m
+    ${CMAKE_SOURCE_DIR}/src/memcached-grammar.m)
+
+set_source_files_properties(${CMAKE_SOURCE_DIR}/src/memcached-grammar.m
+    PROPERTIES HEADER_FILE_ONLY true)
+
+set_source_files_properties(memcached.m
+    PROPERTIES COMPILE_FLAGS "-Wno-uninitialized")
 
 #
 # Do not clean admin.m, memcached.m or other
 # generated files in 'make clean' -- they are under
 # revision control.
 #
-set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM 1)
+set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM true)
 
 #
 # Used by modules.
 #
 set (recompiled_sources
      ${CMAKE_SOURCE_DIR}/src/tarantool.m
-     ${CMAKE_SOURCE_DIR}/src/tarantool_lua.m
+     ${CMAKE_SOURCE_DIR}/src/lua/init.m
      ${CMAKE_SOURCE_DIR}/src/say.m
      ${CMAKE_SOURCE_DIR}/src/assoc.m
-     ${CMAKE_SOURCE_DIR}/src/admin.m
      ${CMAKE_SOURCE_DIR}/src/replication.m
-     ${CMAKE_SOURCE_DIR}/src/fiber.m PARENT_SCOPE)
-
-set (common_sources tbuf.m palloc.m util.m
-     salloc.m pickle.m coro.m stat.m log_io.m recovery.m cpu_feature.m
-     replica.m iproto.m object.m exception.m errcode.c errinj.m latch.m
-     nio.c crc32.c)
+     ${CMAKE_SOURCE_DIR}/src/memcached.m
+     ${CMAKE_SOURCE_DIR}/src/fiber.m)
+
+set (common_sources
+     tbuf.m
+     palloc.m
+     util.m
+     sio.m
+     evio.m
+     coio.m
+     coeio.m
+     iobuf.m
+     coio_buf.m
+     salloc.m
+     pickle.m
+     coro.m
+     stat.m
+     log_io.m
+     recovery.m
+     admin.m
+     cpu_feature.m
+     replica.m
+     iproto.m
+     object.m
+     exception.m
+     errcode.c
+     errinj.m
+     latch.m
+     fio.c
+     crc32.c
+     rope.c
+     ipc.m
+     lua/info.m
+     lua/stat.m
+     lua/slab.m
+     lua/uuid.m
+     lua/lua_ipc.m
+)
 
 if (ENABLE_TRACE)
     set (common_sources ${common_sources} trace.m)
@@ -92,7 +148,7 @@
 add_dependencies(core generate_headers)
 set_target_properties(core PROPERTIES COMPILE_FLAGS "${core_cflags}")
 
-set (common_libraries cfg core ev coro gopt misc)
+set (common_libraries cfg core ev eio coro gopt misc)
 
 set (THREAD_LIB pthread)
 if (ENABLE_STATIC)
@@ -122,4 +178,43 @@
     endif()
 endif()
 
-set (common_libraries ${common_libraries} PARENT_SCOPE) 
+set (common_libraries ${common_libraries} PARENT_SCOPE)
+
+function(tarantool_module mod)
+    set (module_sources ${ARGN})
+    set_source_files_properties(
+        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
+        PROPERTIES COMPILE_FLAGS "-Wno-unused" GENERATED True)
+    add_executable(tarantool_${mod}
+        ${module_sources}
+        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c)
+
+    set_source_files_properties(${recompiled_sources}
+        PROPERTIES OBJECT_DEPENDS
+        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h)
+
+    add_library(lt${mod} STATIC ${recompiled_sources})
+    set_target_properties(lt${mod} PROPERTIES COMPILE_FLAGS
+        "${core_cflags} ${GCOV_C_FLAGS} -DTARANTOOL_CONFIG='<cfg/tarantool_${mod}_cfg.h>'")
+    add_dependencies(lt${mod} generate_headers generate_admin_m generate_memcached_grammar_m build_bundled_libs)
+
+    target_link_libraries(tarantool_${mod} lt${mod} ${GCOV_LDFLAGS} ${common_libraries})
+    set_target_properties(tarantool_${mod} PROPERTIES COMPILE_FLAGS
+        "${core_cflags} ${GCOV_C_FLAGS}")
+
+    if (ENABLE_STATIC)
+        set_target_properties(tarantool_${mod} PROPERTIES
+            LINK_SEARCH_END_STATIC ON)
+        set (module_link_flags "${module_link_flags} -static")
+    endif()
+
+    if (module_link_flags)
+        set_target_properties(tarantool_${mod} PROPERTIES
+            LINK_FLAGS ${module_link_flags})
+    endif()
+    install (TARGETS tarantool_${mod} DESTINATION bin)
+endfunction()
+
+foreach (module ${TARANTOOL_MODULES})
+add_subdirectory(${module})
+endforeach()

=== src/box/CMakeLists.txt ===
if (TARGET_OS_DARWIN)
    set(module_link_flags "-pagezero_size 10000 -image_base 100000000")
endif()

function(lua_source filename)
    get_filename_component(module ${filename} NAME_WE)
    ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_BINARY_DIR}/src/box/${filename}.c
        COMMAND ${ECHO} 'const char ${module}_lua[] =' > ${filename}.new.c
        COMMAND ${CMAKE_BINARY_DIR}/extra/txt2c
            ${CMAKE_SOURCE_DIR}/src/box/${filename} >> ${filename}.new.c
        COMMAND ${ECHO} '\;' >> ${filename}.new.c
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${filename}.new.c
            ${CMAKE_BINARY_DIR}/src/box/${filename}.c
        COMMAND ${CMAKE_COMMAND} -E remove ${filename}.new.c
        DEPENDS ${CMAKE_SOURCE_DIR}/src/box/${filename} txt2c)

    set(lua_sources ${lua_sources} ${CMAKE_BINARY_DIR}/src/box/${filename}.c
        PARENT_SCOPE)
endfunction()

lua_source(box.lua)

add_custom_target(generate_lua_sources}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/box
    DEPENDS ${lua_sources})
set_property(DIRECTORY PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${lua_sources})

tarantool_module("box" tuple.m index.m tree.m space.m port.m request.m
    txn.m box.m ${lua_sources} box_lua.m box_lua_space.m)

=== test/connector_c/CMakeLists.txt ===
include_directories("${PROJECT_SOURCE_DIR}/test/unit")
tarantool_client("tt" tt.c)
tarantool_client("update" update.c)
tarantool_client("xlog" xlog.c)
tarantool_client("rpl" rpl.c)
tarantool_client("snap" snap.c)

## tarantool 1.4.8+20121214

=== debian/changelog ===
tarantool (1.4.8+20121214-1) unstable; urgency=low

  * New snapshot (fix segfault with box.ipc.channel).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 14 Dec 2012 16:39:02 +0400

tarantool (1.4.8+20121207-1) unstable; urgency=low

  * New snapshot (add box.time64 needed by queues).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 07 Dec 2012 14:45:38 +0400

tarantool (1.4.8-1) unstable; urgency=low

  * New tarantool release.

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 23 Nov 2012 11:56:02 +0400

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,7 @@
  python-daemon,
  python-pexpect,
  libncurses5-dev,
- binutils-dev,
- dpkg-dev (>= 1.16.1~)
+ binutils-dev
 Section: database
 Standards-Version: 3.9.3
 Homepage: http://tarantool.org/

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,7 @@
 #!/usr/bin/make -f
 
-DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
-
+#DPKG_EXPORT_BUILDFLAGS = 1
+#include /usr/share/dpkg/buildflags.mk
 
 VERSION  := $(shell dpkg-parsechangelog|grep ^Version|awk '{print $$2}')
 UVERSION := $(shell echo $(VERSION)|sed 's/-[[:digit:]]\+$$//')
